function [Dw] = estimate_delay_until_balance_random_join(W,C)

Psw_0 = 0.33; % Pswitch value at beginning
beta = 1.25;
Z = 60; % periods of switching inactivity forcing mandatory switch
T = 0.25; % period (seconds)
Kss = 6; % when alpha = 0.95

if C>8 || W>40
    fprintf('\n this case is not implemented in the model calculation yet!\n');
    % more channels can be added in a straightforward manner
    return;
end


total_comb=(1/prod(1:C-1))*prod(W+1:W+C-1);
prob_comb=ones(1,total_comb);
if C==2
    comb_count=1;
    for i1=0:W
        comb(comb_count,1:2)=[i1 W-i1];
        for c=1:C-1
            Wres_c=W-sum(comb(comb_count,1:c-1));
    	    prob_comb(comb_count)=prob_comb(comb_count)*nchoosek(Wres_c,comb(comb_count,c))*( ((C-1)^(W-sum(comb(comb_count,1:c))) / C^Wres_c) );
        end
        comb_count=comb_count+1;
    end
end


if C==3
    comb_count=1;
    for i1=0:W
        for i2=0:W-i1
            comb(comb_count,1:3)=[i1 i2 W-i1-i2];
            for c=1:C-1
                Wres_c=W-sum(comb(comb_count,1:c-1));
                prob_comb(comb_count)=prob_comb(comb_count)*nchoosek(Wres_c,comb(comb_count,c))*( ((C-1)^(W-sum(comb(comb_count,1:c))) / C^Wres_c) );
            end
            comb_count=comb_count+1;
        end
    end
end

if C==4
    comb_count=1;
    for i1=0:W
        for i2=0:W-i1
            for i3=0:W-i1-i2
                comb(comb_count,1:4)=[i1 i2 i3 W-i1-i2-i3];
                for c=1:C-1
                    Wres_c=W-sum(comb(comb_count,1:c-1));
                    prob_comb(comb_count)=prob_comb(comb_count)*nchoosek(Wres_c,comb(comb_count,c))*( ((C-1)^(W-sum(comb(comb_count,1:c))) / C^Wres_c) );
                end
                comb_count=comb_count+1;
            end
        end
    end
end

if C==5
    comb_count=1;
    for i1=0:W
        for i2=0:W-i1
            for i3=0:W-i1-i2
                for i4=0:W-i1-i2-i3
                    comb(comb_count,1:5)=[i1 i2 i3 i4 W-i1-i2-i3-i4];
                    for c=1:C-1
                        Wres_c=W-sum(comb(comb_count,1:c-1));
                        prob_comb(comb_count)=prob_comb(comb_count)*nchoosek(Wres_c,comb(comb_count,c))*( ((C-1)^(W-sum(comb(comb_count,1:c))) / C^Wres_c) );
                    end
                    comb_count=comb_count+1;
                end
            end
        end
    end
end
if C==8
    comb_count=1;
    for i1=0:W
        for i2=0:W-i1
            for i3=0:W-i1-i2
                for i4=0:W-i1-i2-i3
                    for i5=0:W-i1-i2-i3-i4
                        for i6=0:W-i1-i2-i3-i4-i5
                             for i7=0:W-i1-i2-i3-i4-i5-i6
                                comb(comb_count,1:8)=[i1 i2 i3 i4 i5 i6 i7 W-i1-i2-i3-i4-i5-i6-i7];
                                for c=1:C-1
                                    Wres_c=W-sum(comb(comb_count,1:c-1));
                                    prob_comb(comb_count)=prob_comb(comb_count)*nchoosek(Wres_c,comb(comb_count,c))*( ((C-1)^(W-sum(comb(comb_count,1:c))) / C^Wres_c) );
                                end
                                comb_count=comb_count+1;
                             end 
                        end
                    end
                end
            end
        end
    end   
end
fprintf('\n Calculated all combinations of %d nodes in %d channels.\n',W,C);

% just to double-check...
if comb_count-1~=total_comb
    fprintf('\n Incorrect calculation: total_comb=%d, comb_count=%d\n\n',total_comb,comb_count);
    return;
end


Dw=0;
for i=1:total_comb
    
    % Find the expected delay for waiting for switching channel
    Wdiff = max(abs(comb(i,:)-round(W/C))); % Maximum imbalance
    S = 0; %initial value
    Psw = Psw_0;
    for k=1:1:Wdiff
        S = S + ((1-(1-(Psw))^(Z*(Wdiff+round(W/C)-k+1)))/(1-(1-(Psw))^(Wdiff+round(W/C)-k+1))) + 2;
        Psw = min(beta*Psw,1);
    end
    
    %Find the total delay until network balance
    Dw = Dw + T*prob_comb(i)*(S);
end
Dw=Dw+Kss*T;
fprintf('\n convergence_delay(%d,%d)=%5.1f sec\n',W,C,Dw);






